// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S144_ExtendAuthorities.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S144_ExtendAuthorities extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int extendAuth = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\1\1"+
    "\1\5\1\0\1\6\1\7\4\10\1\7\1\11\3\7"+
    "\1\12\1\13\5\0\1\14\1\15\1\16\1\17\1\20"+
    "\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30"+
    "\1\31\1\32\1\33\1\34\1\35\1\36\1\37\1\40"+
    "\1\41\1\42\1\25\1\43\1\44\1\45\1\0\1\46"+
    "\1\0\1\47\1\0\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\0\1\61\1\62\1\63"+
    "\1\64\1\65\1\66\1\67\1\70\1\71\1\72\1\73"+
    "\1\74\1\75\1\0\1\76\1\77\265\0\2\60\115\0"+
    "\1\71\u0182\0\1\1\20\0\2\1\u0115\0\1\61\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\105\0\1\5"+
    "\261\0\1\5\31\0\1\6\147\0\1\7\50\0\1\5"+
    "\22\0\1\10\4\0\1\11\31\0\1\5\3\0\1\12"+
    "\4\0\1\13\226\0\1\11";

  private static int [] zzUnpackAction() {
    int [] result = new int[649];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\100\0\200\0\300\0\u0100\0\300\0\u0140\0\300"+
    "\0\u0180\0\u01c0\0\u0200\0\u0240\0\u0280\0\u02c0\0\u0300\0\u0340"+
    "\0\u0380\0\u03c0\0\u0400\0\300\0\u0440\0\u0480\0\u04c0\0\u0500"+
    "\0\u0540\0\u0580\0\u05c0\0\u0600\0\u0640\0\u0680\0\u06c0\0\u0700"+
    "\0\u0740\0\u0780\0\u07c0\0\u0800\0\u0840\0\u0880\0\u08c0\0\u0900"+
    "\0\u0940\0\u0980\0\u09c0\0\u0a00\0\u0a40\0\u0a80\0\u0ac0\0\u0b00"+
    "\0\u0b40\0\u0b80\0\u0bc0\0\u0c00\0\u0c40\0\u0c80\0\u0cc0\0\u0d00"+
    "\0\u0d40\0\u0d80\0\u0dc0\0\u0e00\0\u0e40\0\u0e80\0\u0ec0\0\u0f00"+
    "\0\u0f40\0\u0f80\0\u0fc0\0\u1000\0\u1040\0\u1080\0\u10c0\0\u1100"+
    "\0\u1140\0\u1180\0\u11c0\0\u1200\0\u1240\0\u1280\0\u12c0\0\u1300"+
    "\0\u1340\0\u1380\0\u13c0\0\u1400\0\u1440\0\u1480\0\u14c0\0\u1500"+
    "\0\u1540\0\300\0\u1580\0\u15c0\0\u1600\0\u1640\0\u1680\0\u16c0"+
    "\0\u1700\0\u1740\0\u1780\0\u17c0\0\u1800\0\u1840\0\u1880\0\u18c0"+
    "\0\u1900\0\u1940\0\u1980\0\u19c0\0\u1a00\0\u1a40\0\u1a80\0\u1ac0"+
    "\0\u1b00\0\u1b40\0\u1b80\0\u1bc0\0\u1c00\0\u1c40\0\u1c80\0\u1cc0"+
    "\0\u1d00\0\u1d40\0\u1d80\0\u1dc0\0\u1e00\0\u1e40\0\u1e80\0\u1ec0"+
    "\0\u1f00\0\u1f40\0\u1f80\0\u1fc0\0\u2000\0\u2040\0\u2080\0\u20c0"+
    "\0\u2100\0\u2140\0\u2180\0\u21c0\0\u2200\0\u2240\0\u2280\0\u22c0"+
    "\0\u2300\0\u2340\0\u2380\0\u23c0\0\u2400\0\u2440\0\u2480\0\u24c0"+
    "\0\u2500\0\u2540\0\u2580\0\u25c0\0\u2600\0\u2640\0\u2680\0\u26c0"+
    "\0\u2700\0\u2740\0\u2780\0\u27c0\0\u2800\0\u2840\0\u2880\0\u28c0"+
    "\0\u2900\0\u2940\0\u2980\0\u29c0\0\u2a00\0\u2a40\0\u2a80\0\u2ac0"+
    "\0\u2b00\0\u2b40\0\u2b80\0\u2bc0\0\u2c00\0\u2c40\0\u2c80\0\u2cc0"+
    "\0\u2d00\0\u2d40\0\u2d80\0\u2dc0\0\u2e00\0\u2e40\0\u2e80\0\u2ec0"+
    "\0\u2f00\0\u2f40\0\u2f80\0\u2fc0\0\u3000\0\u3040\0\u3080\0\u30c0"+
    "\0\u3100\0\u3140\0\u3180\0\u31c0\0\u3200\0\u3240\0\u3280\0\u32c0"+
    "\0\u3300\0\u3340\0\u3380\0\u33c0\0\u3400\0\u3440\0\u3480\0\u34c0"+
    "\0\u3500\0\u3540\0\u3580\0\u35c0\0\u3600\0\u3640\0\u3680\0\u36c0"+
    "\0\u3700\0\u3740\0\u3780\0\u37c0\0\u3800\0\u3840\0\u3880\0\u38c0"+
    "\0\u3900\0\u3940\0\u3980\0\u39c0\0\u3a00\0\u3a40\0\u3a80\0\u3ac0"+
    "\0\u3b00\0\u3b40\0\u3b80\0\u3bc0\0\u3c00\0\u3c40\0\u3c80\0\u3cc0"+
    "\0\u3d00\0\u3d40\0\u3d80\0\u3dc0\0\u3e00\0\u3e40\0\u3e80\0\u3ec0"+
    "\0\u3f00\0\u3f40\0\u3f80\0\u3fc0\0\u4000\0\u4040\0\u4080\0\u40c0"+
    "\0\u4100\0\u4140\0\u4180\0\u41c0\0\u4200\0\u4240\0\u4280\0\u42c0"+
    "\0\u4300\0\u4340\0\u4380\0\u43c0\0\u41c0\0\u4400\0\u4440\0\u4480"+
    "\0\u44c0\0\u4500\0\u4540\0\u4580\0\u45c0\0\u4600\0\u4640\0\u4680"+
    "\0\u46c0\0\u4700\0\u4740\0\u4780\0\u47c0\0\300\0\u4800\0\u4840"+
    "\0\u4880\0\u48c0\0\u4900\0\u4940\0\u4980\0\u49c0\0\u4a00\0\u4a40"+
    "\0\u4a80\0\u4ac0\0\u4b00\0\u4b40\0\u4b80\0\u4bc0\0\u4c00\0\u4c40"+
    "\0\u4c80\0\u4cc0\0\u4d00\0\u4d40\0\u4d80\0\u4dc0\0\u4e00\0\u4e40"+
    "\0\u4e80\0\u4ec0\0\u4f00\0\u4f40\0\u4f80\0\u4fc0\0\u5000\0\u5040"+
    "\0\u5080\0\u50c0\0\u5100\0\u5140\0\u5180\0\u51c0\0\u5200\0\u5240"+
    "\0\u5280\0\u52c0\0\u5300\0\u5340\0\u5380\0\u53c0\0\u5400\0\u5440"+
    "\0\u5480\0\u54c0\0\u5500\0\u5540\0\u5580\0\u55c0\0\u5600\0\u5640"+
    "\0\u5680\0\u56c0\0\u5700\0\u5740\0\u5780\0\u57c0\0\u5800\0\u5840"+
    "\0\u5880\0\u58c0\0\u5900\0\u5940\0\u5980\0\u59c0\0\u5a00\0\u5a40"+
    "\0\u5a80\0\u5ac0\0\u5b00\0\u5b40\0\u5b80\0\u5bc0\0\u5c00\0\u5c40"+
    "\0\u5c80\0\u5cc0\0\u5d00\0\u5d40\0\u5d80\0\u5dc0\0\u5e00\0\u5e40"+
    "\0\u5e80\0\u5ec0\0\u5f00\0\u5f40\0\u5f80\0\u5fc0\0\u6000\0\u6040"+
    "\0\u6080\0\u60c0\0\u6100\0\u6140\0\u6180\0\300\0\u61c0\0\u6200"+
    "\0\u6240\0\u6280\0\u62c0\0\u6300\0\u6340\0\u6380\0\u63c0\0\u6400"+
    "\0\u6440\0\u6480\0\u64c0\0\u6500\0\u6540\0\u6580\0\u65c0\0\u6600"+
    "\0\u6640\0\u6680\0\u66c0\0\u6700\0\u6740\0\u6780\0\u67c0\0\u6800"+
    "\0\u6840\0\u6880\0\u68c0\0\u6900\0\u6940\0\u6980\0\u69c0\0\u6a00"+
    "\0\u6a40\0\u6a80\0\u6ac0\0\u6b00\0\u6b40\0\u6b80\0\u6bc0\0\u6c00"+
    "\0\u6bc0\0\u6c40\0\u6c80\0\u6cc0\0\u6d00\0\u6d40\0\u6d80\0\u6dc0"+
    "\0\u6e00\0\u6e40\0\u6e80\0\u6ec0\0\u6f00\0\u6f40\0\u6f80\0\u6fc0"+
    "\0\u7000\0\300\0\u7040\0\u7080\0\u70c0\0\u7100\0\u7140\0\u7180"+
    "\0\u71c0\0\u7200\0\u7240\0\u7280\0\u72c0\0\u7300\0\u7340\0\u7380"+
    "\0\u73c0\0\u7400\0\u7440\0\u7140\0\u7480\0\u74c0\0\u7500\0\u7540"+
    "\0\u7580\0\u75c0\0\u7600\0\u7640\0\u7680\0\u76c0\0\u7700\0\u7740"+
    "\0\u7780\0\u7780\0\u77c0\0\u7800\0\300\0\u7840\0\u7880\0\u78c0"+
    "\0\u7900\0\300\0\u7940\0\u7980\0\u79c0\0\u7a00\0\u7a40\0\u7a80"+
    "\0\u7ac0\0\u7b00\0\u7b40\0\u7b80\0\u7bc0\0\u7c00\0\u7c40\0\u7c80"+
    "\0\u7cc0\0\u7d00\0\u7d40\0\u7d80\0\u7dc0\0\u7e00\0\u7e40\0\u7e80"+
    "\0\u7ec0\0\u7f00\0\u7f40\0\u7f80\0\u7fc0\0\u8000\0\u8040\0\u8080"+
    "\0\u80c0\0\u8100\0\u8140\0\u8180\0\u81c0\0\u8200\0\u8240\0\u8280"+
    "\0\u82c0\0\u8300\0\u8340\0\u8380\0\u83c0\0\u8400\0\u8440\0\u8480"+
    "\0\u84c0\0\u8500\0\u8540\0\u8580\0\u85c0\0\u8600\0\u8640\0\u8680"+
    "\0\u86c0\0\u8700\0\u8740\0\u8780\0\u87c0\0\u8800\0\u8840\0\u8880"+
    "\0\u88c0\0\u8900\0\u8940\0\u8980\0\u89c0\0\u8a00\0\u8a40\0\u8a80"+
    "\0\u8ac0\0\u8b00\0\u8b40\0\u8b80\0\u8bc0\0\u8c00\0\u8c40\0\u8c80"+
    "\0\u8cc0\0\u8d00\0\u8d40\0\u8d80\0\u8dc0\0\u8e00\0\u8e40\0\u8e80"+
    "\0\u8ec0\0\u8f00\0\u8f40\0\u8f80\0\u8fc0\0\u9000\0\u9040\0\u9080"+
    "\0\u90c0\0\u9100\0\u9140\0\u9180\0\u91c0\0\u9200\0\u9240\0\u9280"+
    "\0\u92c0\0\u9300\0\u9340\0\u9380\0\u93c0\0\u9400\0\u9440\0\u9480"+
    "\0\u94c0\0\u9500\0\u9540\0\u9580\0\u95c0\0\u9600\0\u9640\0\u9680"+
    "\0\u96c0\0\u9700\0\u9740\0\u9780\0\u97c0\0\u9800\0\u9840\0\u9880"+
    "\0\u98c0\0\u9900\0\u9940\0\u9980\0\u99c0\0\u9a00\0\u9a40\0\u9a80"+
    "\0\u9ac0\0\u9b00\0\u9b40\0\u9b80\0\u9bc0\0\u9c00\0\u9c40\0\u9c80"+
    "\0\u9cc0\0\u9d00\0\u9d40\0\u9d80\0\u9dc0\0\u9e00\0\u9e40\0\u9e80"+
    "\0\300";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[649];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\45\4\1\5\32\4\45\6\1\7\32\6\45\10\1\11"+
    "\32\10\127\0\1\12\32\0\1\12\23\0\1\13\120\0"+
    "\1\14\32\0\1\14\43\0\1\15\32\0\1\15\45\0"+
    "\1\16\32\0\1\16\43\0\1\17\32\0\1\17\47\0"+
    "\1\20\32\0\1\20\41\0\1\21\32\0\1\21\47\0"+
    "\1\22\32\0\1\22\25\0\1\23\116\0\1\24\32\0"+
    "\1\24\25\0\1\25\101\0\1\26\1\27\1\30\1\27"+
    "\1\31\24\27\2\0\1\27\1\32\1\0\1\33\1\0"+
    "\1\34\37\0\2\35\1\36\11\35\1\37\4\35\1\40"+
    "\7\35\2\0\1\35\2\0\1\41\10\0\1\42\4\0"+
    "\1\43\21\0\1\44\1\0\24\27\1\45\4\27\2\0"+
    "\1\27\23\0\1\46\16\0\1\44\1\0\31\27\2\0"+
    "\1\27\42\0\1\44\1\0\13\27\1\47\15\27\2\0"+
    "\1\27\12\0\1\50\27\0\1\44\1\0\24\27\1\51"+
    "\4\27\2\0\1\27\23\0\1\52\44\0\1\46\32\0"+
    "\1\46\33\0\1\50\32\0\1\50\55\0\1\52\32\0"+
    "\1\52\16\0\1\53\1\0\31\35\2\0\1\35\42\0"+
    "\1\53\1\0\10\35\1\54\2\35\1\55\15\35\2\0"+
    "\1\35\10\0\1\56\1\0\1\57\27\0\1\53\1\0"+
    "\24\35\1\60\4\35\2\0\1\35\23\0\1\61\16\0"+
    "\1\53\1\0\4\35\1\62\24\35\2\0\1\35\4\0"+
    "\1\63\47\0\1\56\2\0\1\57\30\0\1\56\1\0"+
    "\1\57\55\0\1\61\32\0\1\61\24\0\1\63\33\0"+
    "\1\63\23\0\2\44\2\0\6\44\1\64\32\44\2\0"+
    "\31\44\12\0\1\44\1\0\23\27\1\65\5\27\2\0"+
    "\1\27\22\0\1\66\44\0\1\66\32\0\1\66\17\0"+
    "\1\44\1\0\31\27\2\0\1\67\77\0\1\70\42\0"+
    "\1\44\1\0\31\27\2\0\1\71\77\0\1\72\30\0"+
    "\2\53\2\0\6\53\1\73\32\53\2\0\31\53\12\0"+
    "\1\53\1\0\23\35\1\74\5\35\2\0\1\35\22\0"+
    "\1\75\17\0\1\53\1\0\31\35\2\0\1\76\67\0"+
    "\1\75\32\0\1\75\54\0\1\77\42\0\1\53\1\0"+
    "\15\35\1\100\13\35\2\0\1\35\14\0\1\101\44\0"+
    "\1\101\32\0\1\101\25\0\1\53\1\0\6\35\1\102"+
    "\22\35\2\0\1\35\6\0\1\103\43\0\1\103\33\0"+
    "\1\103\30\0\3\104\100\0\1\44\1\0\7\27\1\105"+
    "\21\27\2\0\1\27\7\0\1\106\43\0\1\106\33\0"+
    "\1\106\32\0\1\44\1\0\1\107\21\27\1\110\6\27"+
    "\2\0\1\27\1\111\20\0\1\112\22\0\1\111\21\0"+
    "\1\112\11\0\1\111\20\0\1\112\20\0\1\44\1\0"+
    "\1\26\1\27\1\113\26\27\2\0\1\27\1\32\1\0"+
    "\1\114\41\0\1\32\1\0\1\114\31\0\1\32\1\0"+
    "\1\114\34\0\3\115\100\0\1\53\1\0\27\35\1\116"+
    "\1\35\2\0\1\35\26\0\1\117\44\0\1\117\32\0"+
    "\1\117\13\0\1\53\1\0\1\120\2\35\1\121\16\35"+
    "\1\122\6\35\2\0\1\35\1\123\2\0\1\124\15\0"+
    "\1\125\22\0\1\123\2\0\1\124\16\0\1\125\11\0"+
    "\1\123\2\0\1\124\15\0\1\125\20\0\1\53\1\0"+
    "\10\35\1\126\20\35\2\0\1\35\10\0\1\127\43\0"+
    "\1\127\33\0\1\127\31\0\1\53\1\0\10\35\1\130"+
    "\20\35\2\0\1\35\10\0\1\131\43\0\1\131\33\0"+
    "\1\131\26\0\3\104\34\0\1\132\43\0\1\133\1\0"+
    "\31\27\2\0\1\27\42\0\1\134\77\0\1\44\1\0"+
    "\24\27\1\135\4\27\2\0\1\27\23\0\1\136\16\0"+
    "\1\44\1\0\4\27\1\137\24\27\2\0\1\27\4\0"+
    "\1\140\63\0\1\136\32\0\1\136\24\0\1\140\33\0"+
    "\1\140\35\0\1\44\1\0\13\27\1\141\15\27\2\0"+
    "\1\27\12\0\1\142\44\0\1\142\32\0\1\142\24\0"+
    "\3\115\34\0\1\143\43\0\1\144\1\0\31\35\2\0"+
    "\1\35\42\0\1\144\77\0\1\53\1\0\24\35\1\145"+
    "\4\35\2\0\1\35\23\0\1\146\16\0\1\53\1\0"+
    "\4\35\1\147\24\35\2\0\1\35\4\0\1\150\35\0"+
    "\1\53\1\0\4\35\1\151\24\35\2\0\1\35\4\0"+
    "\1\152\63\0\1\146\32\0\1\146\24\0\1\150\33\0"+
    "\1\150\43\0\1\152\33\0\1\152\35\0\1\53\1\0"+
    "\2\35\1\153\26\35\2\0\1\35\2\0\1\154\43\0"+
    "\1\154\33\0\1\154\37\0\1\53\1\0\16\35\1\155"+
    "\12\35\2\0\1\35\15\0\1\156\44\0\1\156\32\0"+
    "\1\156\12\0\2\44\2\0\6\44\1\64\3\44\1\157"+
    "\3\44\1\160\10\44\1\161\3\44\1\162\1\163\4\44"+
    "\2\0\3\44\1\157\3\44\1\160\7\44\1\161\3\44"+
    "\1\162\1\163\4\44\16\0\1\164\3\0\1\165\10\0"+
    "\1\166\3\0\1\167\1\170\11\0\1\164\3\0\1\165"+
    "\7\0\1\166\3\0\1\167\1\170\16\0\1\44\1\0"+
    "\23\27\1\171\5\27\2\0\1\27\22\0\1\172\44\0"+
    "\1\172\32\0\1\172\17\0\1\44\1\0\2\27\1\173"+
    "\26\27\2\0\1\27\2\0\1\174\43\0\1\174\33\0"+
    "\1\174\37\0\1\44\1\0\31\27\2\0\1\175\77\0"+
    "\1\176\30\0\45\177\1\0\32\177\2\144\2\0\6\144"+
    "\1\200\32\144\2\0\31\144\12\0\1\53\1\0\23\35"+
    "\1\201\5\35\2\0\1\35\22\0\1\202\44\0\1\202"+
    "\32\0\1\202\17\0\1\53\1\0\23\35\1\203\5\35"+
    "\2\0\1\35\22\0\1\204\44\0\1\204\32\0\1\204"+
    "\17\0\1\53\1\0\2\35\1\205\26\35\2\0\1\35"+
    "\2\0\1\206\43\0\1\206\33\0\1\206\37\0\1\53"+
    "\1\0\10\35\1\207\20\35\2\0\1\35\10\0\1\210"+
    "\43\0\1\210\33\0\1\210\31\0\1\53\1\0\15\35"+
    "\1\116\13\35\2\0\1\35\14\0\1\117\44\0\1\117"+
    "\32\0\1\117\13\0\2\44\2\0\6\44\1\64\17\44"+
    "\1\211\12\44\2\0\16\44\1\211\14\44\2\0\6\44"+
    "\1\64\11\44\1\212\20\44\2\0\11\44\1\212\21\44"+
    "\2\0\6\44\1\64\22\44\1\213\7\44\2\0\21\44"+
    "\1\213\11\44\2\0\6\44\1\64\22\44\1\214\7\44"+
    "\2\0\21\44\1\214\11\44\2\0\6\44\1\64\6\44"+
    "\1\215\23\44\2\0\6\44\1\215\22\44\32\0\1\216"+
    "\32\0\1\216\36\0\1\217\33\0\1\217\54\0\1\220"+
    "\32\0\1\220\44\0\1\221\32\0\1\221\30\0\1\222"+
    "\33\0\1\222\34\0\1\44\1\0\7\27\1\223\21\27"+
    "\2\0\1\27\7\0\1\224\43\0\1\224\33\0\1\224"+
    "\32\0\1\44\1\0\23\27\1\225\5\27\2\0\1\27"+
    "\22\0\1\226\44\0\1\226\32\0\1\226\17\0\1\44"+
    "\1\0\1\26\30\27\2\0\1\27\1\32\43\0\1\32"+
    "\33\0\1\32\27\0\45\177\1\227\32\177\7\0\3\230"+
    "\100\0\1\53\1\0\7\35\1\231\21\35\2\0\1\35"+
    "\7\0\1\232\43\0\1\232\33\0\1\232\32\0\1\53"+
    "\1\0\1\233\30\35\2\0\1\35\1\234\43\0\1\234"+
    "\33\0\1\234\41\0\1\53\1\0\23\35\1\235\5\35"+
    "\2\0\1\35\22\0\1\236\44\0\1\236\32\0\1\236"+
    "\17\0\1\53\1\0\17\35\1\237\11\35\2\0\1\35"+
    "\16\0\1\240\44\0\1\240\32\0\1\240\11\0\2\44"+
    "\2\0\6\44\1\64\15\44\1\241\4\44\1\242\7\44"+
    "\2\0\14\44\1\241\4\44\1\242\11\44\2\0\6\44"+
    "\1\64\25\44\1\243\4\44\2\0\24\44\1\243\6\44"+
    "\2\0\6\44\1\64\5\44\1\244\11\44\1\245\12\44"+
    "\2\0\5\44\1\244\10\44\1\245\14\44\2\0\6\44"+
    "\1\64\11\44\1\246\20\44\2\0\11\44\1\246\21\44"+
    "\2\0\6\44\1\64\6\44\1\247\23\44\2\0\6\44"+
    "\1\247\22\44\30\0\1\250\4\0\1\251\25\0\1\250"+
    "\4\0\1\251\47\0\1\252\32\0\1\252\24\0\1\253"+
    "\11\0\1\254\21\0\1\253\10\0\1\254\36\0\1\255"+
    "\33\0\1\255\40\0\1\256\33\0\1\256\34\0\1\257"+
    "\1\0\31\27\2\0\1\27\42\0\1\260\77\0\1\44"+
    "\1\0\10\27\1\261\20\27\2\0\1\27\10\0\1\262"+
    "\43\0\1\262\33\0\1\262\25\0\1\263\100\0\3\230"+
    "\34\0\1\264\43\0\1\265\1\0\31\35\2\0\1\35"+
    "\42\0\1\265\77\0\1\53\1\0\2\35\1\266\26\35"+
    "\2\0\1\35\2\0\1\267\43\0\1\267\33\0\1\267"+
    "\37\0\1\53\1\0\10\35\1\270\20\35\2\0\1\35"+
    "\10\0\1\271\43\0\1\271\33\0\1\271\31\0\1\53"+
    "\1\0\1\272\30\35\2\0\1\35\1\273\43\0\1\273"+
    "\33\0\1\273\27\0\2\44\2\0\6\44\1\64\15\44"+
    "\1\274\14\44\2\0\14\44\1\274\16\44\2\0\6\44"+
    "\1\64\24\44\1\275\5\44\2\0\23\44\1\275\7\44"+
    "\2\0\6\44\1\64\4\44\1\276\25\44\2\0\4\44"+
    "\1\276\26\44\2\0\6\44\1\64\24\44\1\277\5\44"+
    "\2\0\23\44\1\277\7\44\2\0\6\44\1\64\3\44"+
    "\1\277\26\44\2\0\3\44\1\277\27\44\2\0\6\44"+
    "\1\64\2\44\1\300\27\44\2\0\2\44\1\300\30\44"+
    "\2\0\6\44\1\64\32\44\2\0\1\301\30\44\30\0"+
    "\1\302\32\0\1\302\53\0\1\303\32\0\1\303\24\0"+
    "\1\304\33\0\1\304\63\0\1\305\32\0\1\305\23\0"+
    "\1\305\33\0\1\305\42\0\1\306\33\0\1\306\75\0"+
    "\1\307\30\0\2\44\2\0\6\44\1\64\3\44\1\310"+
    "\3\44\1\160\10\44\1\161\3\44\1\162\1\163\4\44"+
    "\2\0\3\44\1\310\3\44\1\160\7\44\1\161\3\44"+
    "\1\162\1\163\4\44\16\0\1\311\3\0\1\165\10\0"+
    "\1\166\3\0\1\167\1\170\11\0\1\311\3\0\1\165"+
    "\7\0\1\166\3\0\1\167\1\170\16\0\1\44\1\0"+
    "\16\27\1\312\12\27\2\0\1\27\15\0\1\313\44\0"+
    "\1\313\32\0\1\313\41\0\1\314\32\0\1\314\15\0"+
    "\45\315\1\0\32\315\2\265\2\0\6\265\1\316\32\265"+
    "\2\0\31\265\12\0\1\53\1\0\7\35\1\317\21\35"+
    "\2\0\1\35\7\0\1\320\43\0\1\320\33\0\1\320"+
    "\32\0\1\53\1\0\16\35\1\321\12\35\2\0\1\35"+
    "\15\0\1\322\44\0\1\322\32\0\1\322\24\0\1\53"+
    "\1\0\13\35\1\323\15\35\2\0\1\35\12\0\1\324"+
    "\44\0\1\324\32\0\1\324\15\0\2\44\2\0\6\44"+
    "\1\64\32\44\2\0\1\325\32\44\2\0\6\44\1\64"+
    "\5\44\1\326\24\44\2\0\5\44\1\326\25\44\2\0"+
    "\6\44\1\64\11\44\1\327\20\44\2\0\11\44\1\327"+
    "\21\44\2\0\6\44\1\64\25\44\1\330\4\44\2\0"+
    "\24\44\1\330\6\44\2\0\6\44\1\331\32\44\2\0"+
    "\1\332\32\44\2\0\6\44\1\64\23\44\1\333\6\44"+
    "\2\0\22\44\1\333\6\44\47\0\1\334\50\0\1\335"+
    "\33\0\1\335\47\0\1\336\33\0\1\336\57\0\1\337"+
    "\32\0\1\337\16\0\1\340\34\0\1\341\66\0\1\342"+
    "\32\0\1\342\6\0\2\44\2\0\6\44\1\64\17\44"+
    "\1\343\12\44\2\0\16\44\1\343\12\44\32\0\1\344"+
    "\32\0\1\344\24\0\1\44\1\0\15\27\1\345\13\27"+
    "\2\0\1\27\14\0\1\346\44\0\1\346\32\0\1\346"+
    "\41\0\1\347\32\0\1\347\16\0\45\315\1\350\32\315"+
    "\7\0\3\351\100\0\1\53\1\0\4\35\1\352\24\35"+
    "\2\0\1\35\4\0\1\353\43\0\1\353\33\0\1\353"+
    "\35\0\1\53\1\0\15\35\1\354\13\35\2\0\1\35"+
    "\14\0\1\355\44\0\1\355\32\0\1\355\25\0\1\53"+
    "\1\0\10\35\1\54\20\35\2\0\1\35\10\0\1\56"+
    "\43\0\1\56\33\0\1\56\17\0\2\44\2\0\6\44"+
    "\1\64\24\44\1\356\5\44\2\0\23\44\1\356\7\44"+
    "\2\0\6\44\1\64\32\44\2\0\1\357\32\44\2\0"+
    "\6\44\1\64\3\44\1\360\26\44\2\0\3\44\1\360"+
    "\27\44\2\0\6\44\1\64\22\44\1\361\7\44\2\0"+
    "\21\44\1\361\7\44\7\0\3\362\66\0\2\44\2\0"+
    "\6\44\1\64\1\44\1\363\13\44\1\364\5\44\1\333"+
    "\6\44\2\0\1\44\1\363\12\44\1\364\5\44\1\333"+
    "\10\44\2\0\6\44\1\64\17\44\1\365\12\44\2\0"+
    "\16\44\1\365\12\44\37\0\1\366\32\0\1\366\54\0"+
    "\1\367\46\0\1\370\33\0\1\370\62\0\1\371\32\0"+
    "\1\371\16\0\3\372\102\0\1\373\13\0\1\374\5\0"+
    "\1\342\11\0\1\373\12\0\1\374\5\0\1\342\40\0"+
    "\1\375\32\0\1\375\12\0\2\44\2\0\6\44\1\64"+
    "\15\44\1\241\4\44\1\376\7\44\2\0\14\44\1\241"+
    "\4\44\1\376\7\44\30\0\1\250\4\0\1\377\25\0"+
    "\1\250\4\0\1\377\21\0\1\u0100\1\0\31\27\2\0"+
    "\1\27\42\0\1\u0101\116\0\1\u0102\32\0\1\u0102\21\0"+
    "\1\u0103\100\0\3\351\34\0\1\u0104\43\0\1\53\1\0"+
    "\3\35\1\u0105\25\35\2\0\1\35\3\0\1\u0106\43\0"+
    "\1\u0106\33\0\1\u0106\36\0\1\u0107\1\0\31\35\2\0"+
    "\1\35\42\0\1\u0107\65\0\2\44\2\0\6\44\1\64"+
    "\22\44\1\u0108\7\44\2\0\21\44\1\u0108\11\44\2\0"+
    "\6\44\1\64\1\44\1\u0109\30\44\2\0\1\44\1\u0109"+
    "\31\44\2\0\6\44\1\64\5\44\1\u010a\24\44\2\0"+
    "\5\44\1\u010a\25\44\2\0\6\44\1\64\1\44\1\u010b"+
    "\30\44\2\0\1\44\1\u010b\27\44\7\0\3\362\34\0"+
    "\1\u010c\31\0\2\44\2\0\6\44\1\64\3\44\1\u010d"+
    "\11\44\1\u010e\14\44\2\0\3\44\1\u010d\10\44\1\u010e"+
    "\16\44\2\0\6\44\1\64\11\44\1\u010f\20\44\2\0"+
    "\11\44\1\u010f\21\44\2\0\6\44\1\64\22\44\1\u0110"+
    "\7\44\2\0\21\44\1\u0110\7\44\35\0\1\u0111\32\0"+
    "\1\u0111\23\0\1\u0112\33\0\1\u0112\47\0\1\u0113\33\0"+
    "\1\u0113\37\0\1\u0114\33\0\1\u0114\36\0\3\372\34\0"+
    "\1\u0115\47\0\1\u0116\11\0\1\u0117\21\0\1\u0116\10\0"+
    "\1\u0117\40\0\1\u0118\33\0\1\u0118\54\0\1\u0119\32\0"+
    "\1\u0119\7\0\2\44\2\0\6\44\1\64\24\44\1\u011a"+
    "\5\44\2\0\23\44\1\u011a\5\44\37\0\1\u011b\32\0"+
    "\1\u011b\5\0\2\44\2\0\5\44\1\u011c\1\64\6\44"+
    "\1\u011d\5\44\1\u011e\7\44\1\u011f\1\u0120\4\44\2\0"+
    "\6\44\1\u011d\4\44\1\u011e\7\44\1\u011f\1\u0120\4\44"+
    "\11\0\1\u0121\7\0\1\u0122\5\0\1\u0123\7\0\1\u0124"+
    "\1\u0125\14\0\1\u0122\4\0\1\u0123\7\0\1\u0124\1\u0125"+
    "\52\0\1\u0126\60\0\1\u0127\32\0\1\u0127\15\0\45\u0128"+
    "\1\0\32\u0128\12\0\1\u0129\1\0\31\35\2\0\1\35"+
    "\42\0\1\u0129\65\0\2\u0107\2\0\6\u0107\1\u012a\32\u0107"+
    "\2\0\31\u0107\2\44\2\0\6\44\1\64\11\44\1\u012b"+
    "\20\44\2\0\11\44\1\u012b\21\44\2\0\6\44\1\64"+
    "\20\44\1\u012c\2\44\1\u012d\6\44\2\0\17\44\1\u012c"+
    "\2\44\1\u012d\10\44\2\0\6\44\1\64\32\44\2\0"+
    "\1\u012e\32\44\2\0\6\44\1\331\32\44\2\0\31\44"+
    "\45\u012f\1\0\32\u012f\2\44\2\0\6\44\1\64\21\44"+
    "\1\u0130\10\44\2\0\20\44\1\u0130\12\44\2\0\6\44"+
    "\1\64\15\44\1\u0131\14\44\2\0\14\44\1\u0131\16\44"+
    "\2\0\6\44\1\64\14\44\1\u0132\1\44\1\u0133\13\44"+
    "\2\0\13\44\1\u0132\1\44\1\u0133\15\44\2\0\6\44"+
    "\1\64\26\44\1\u0134\3\44\2\0\25\44\1\u0134\3\44"+
    "\24\0\1\u0135\33\0\1\u0135\52\0\1\u0136\2\0\1\u0137"+
    "\27\0\1\u0136\2\0\1\u0137\55\0\1\u0138\42\0\1\340"+
    "\121\0\1\u0139\32\0\1\u0139\40\0\1\u013a\32\0\1\u013a"+
    "\43\0\1\u013b\1\0\1\u013c\30\0\1\u013b\1\0\1\u013c"+
    "\54\0\1\u013d\32\0\1\u013d\3\0\2\44\2\0\6\44"+
    "\1\64\5\44\1\u013e\24\44\2\0\5\44\1\u013e\23\44"+
    "\20\0\1\u013f\33\0\1\u013f\23\0\2\44\2\0\1\44"+
    "\1\u0140\4\44\1\64\32\44\2\0\33\44\2\0\6\44"+
    "\1\64\5\44\1\u0141\24\44\2\0\5\44\1\u0141\25\44"+
    "\2\0\6\44\1\64\1\44\1\u0142\30\44\2\0\1\44"+
    "\1\u0142\31\44\2\0\6\44\1\64\22\44\1\u0143\7\44"+
    "\2\0\21\44\1\u0143\11\44\2\0\6\44\1\64\16\44"+
    "\1\u0144\13\44\2\0\15\44\1\u0144\13\44\5\0\1\u0145"+
    "\112\0\1\u0146\33\0\1\u0146\37\0\1\u0147\33\0\1\u0147"+
    "\64\0\1\u0148\32\0\1\u0148\40\0\1\u0149\32\0\1\u0149"+
    "\41\0\1\u014a\32\0\1\u014a\16\0\45\u0128\1\u014b\32\u0128"+
    "\2\u0129\2\0\6\u0129\1\u014c\32\u0129\2\0\31\u0129\7\0"+
    "\3\u014d\66\0\2\44\2\0\6\44\1\64\2\44\1\u014e"+
    "\27\44\2\0\2\44\1\u014e\30\44\2\0\6\44\1\64"+
    "\20\44\1\u014f\11\44\2\0\17\44\1\u014f\13\44\2\0"+
    "\6\44\1\64\23\44\1\u0150\6\44\2\0\22\44\1\u0150"+
    "\10\44\2\0\6\44\1\64\20\44\1\u0151\11\44\2\0"+
    "\17\44\1\u0151\11\44\45\u012f\1\u0152\32\u012f\2\44\2\0"+
    "\6\44\1\64\25\44\1\u0153\4\44\2\0\24\44\1\u0153"+
    "\6\44\2\0\6\44\1\64\32\44\2\0\1\u0154\32\44"+
    "\2\0\6\44\1\64\11\44\1\u0155\20\44\2\0\11\44"+
    "\1\u0155\21\44\2\0\6\44\1\64\17\44\1\u0156\12\44"+
    "\2\0\16\44\1\u0156\14\44\2\0\6\44\1\64\5\44"+
    "\1\u0157\24\44\2\0\5\44\1\u0157\23\44\15\0\1\u0158"+
    "\33\0\1\u0158\61\0\1\u0159\32\0\1\u0159\47\0\1\u015a"+
    "\32\0\1\u015a\41\0\1\u015b\32\0\1\u015b\51\0\1\u015c"+
    "\32\0\1\u015c\53\0\1\u015d\54\0\1\u015e\33\0\1\u015e"+
    "\51\0\1\u015f\32\0\1\u015f\32\0\1\u0160\33\0\1\u0160"+
    "\23\0\2\44\2\0\6\44\1\64\32\44\2\0\1\u0161"+
    "\30\44\47\0\1\u0162\30\0\2\44\2\0\4\44\1\u0163"+
    "\1\44\1\64\32\44\2\0\33\44\2\0\6\44\1\64"+
    "\22\44\1\u0164\7\44\2\0\21\44\1\u0164\11\44\2\0"+
    "\6\44\1\64\26\44\1\u0165\3\44\2\0\25\44\1\u0165"+
    "\5\44\2\0\6\44\1\64\11\44\1\u0166\20\44\2\0"+
    "\11\44\1\u0166\21\44\2\0\6\44\1\64\11\44\1\u0167"+
    "\20\44\2\0\11\44\1\u0167\17\44\10\0\1\u0168\124\0"+
    "\1\u0169\32\0\1\u0169\50\0\1\u016a\32\0\1\u016a\27\0"+
    "\1\u016b\33\0\1\u016b\43\0\1\u016c\33\0\1\u016c\50\0"+
    "\1\u016d\32\0\1\u016d\21\0\1\u016e\100\0\3\u016f\75\0"+
    "\3\u014d\34\0\1\u0170\31\0\2\44\2\0\6\44\1\64"+
    "\25\44\1\u0171\4\44\2\0\24\44\1\u0171\6\44\2\0"+
    "\6\44\1\64\5\44\1\u0172\24\44\2\0\5\44\1\u0172"+
    "\25\44\2\0\6\44\1\64\11\44\1\u0173\20\44\2\0"+
    "\11\44\1\u0173\21\44\2\0\6\44\1\64\1\44\1\u0174"+
    "\30\44\2\0\1\44\1\u0174\27\44\6\0\1\u0175\71\0"+
    "\2\44\2\0\6\44\1\64\5\44\1\u010b\24\44\2\0"+
    "\5\44\1\u010b\25\44\2\0\6\44\1\64\22\44\1\u0176"+
    "\7\44\2\0\21\44\1\u0176\11\44\2\0\6\44\1\64"+
    "\24\44\1\u0177\5\44\2\0\23\44\1\u0177\7\44\2\0"+
    "\6\44\1\64\22\44\1\u0178\7\44\2\0\21\44\1\u0178"+
    "\11\44\2\0\6\44\1\64\7\44\1\u0179\22\44\2\0"+
    "\7\44\1\u0179\21\44\40\0\1\u017a\32\0\1\u017a\24\0"+
    "\1\u017b\33\0\1\u017b\47\0\1\u017c\33\0\1\u017c\33\0"+
    "\1\u017d\33\0\1\u017d\47\0\1\u0114\33\0\1\u0114\60\0"+
    "\1\u017e\32\0\1\u017e\46\0\1\u017f\32\0\1\u017f\42\0"+
    "\1\u0180\32\0\1\u0180\31\0\1\u0181\33\0\1\u0181\21\0"+
    "\2\44\2\0\6\44\1\64\1\44\1\u0109\1\44\1\u0182"+
    "\26\44\2\0\1\44\1\u0109\1\44\1\u0182\25\44\14\0"+
    "\1\u0112\1\0\1\u0183\31\0\1\u0112\1\0\1\u0183\25\0"+
    "\2\44\2\0\6\44\1\u0184\32\44\2\0\33\44\2\0"+
    "\6\44\1\64\11\44\1\u0185\20\44\2\0\11\44\1\u0185"+
    "\21\44\2\0\6\44\1\64\17\44\1\u0186\12\44\2\0"+
    "\16\44\1\u0186\14\44\2\0\6\44\1\64\2\44\1\u0187"+
    "\27\44\2\0\2\44\1\u0187\30\44\2\0\6\44\1\64"+
    "\24\44\1\u0188\5\44\2\0\23\44\1\u0188\5\44\12\0"+
    "\1\u0189\111\0\1\u018a\33\0\1\u018a\51\0\1\u018b\32\0"+
    "\1\u018b\27\0\1\u018c\33\0\1\u018c\65\0\1\u018d\32\0"+
    "\1\u018d\53\0\1\u018e\60\0\1\u018f\32\0\1\u018f\24\0"+
    "\3\u016f\34\0\1\u0190\31\0\45\u0191\1\0\32\u0191\2\44"+
    "\2\0\6\44\1\64\24\44\1\u0192\5\44\2\0\23\44"+
    "\1\u0192\7\44\2\0\6\44\1\64\14\44\1\u0193\15\44"+
    "\2\0\13\44\1\u0193\17\44\2\0\6\44\1\64\23\44"+
    "\1\u0194\6\44\2\0\22\44\1\u0194\10\44\2\0\6\44"+
    "\1\64\3\44\1\u0153\26\44\2\0\3\44\1\u0153\25\44"+
    "\27\0\1\u0195\32\0\1\u0195\15\0\2\44\2\0\6\44"+
    "\1\64\5\44\1\u0196\24\44\2\0\5\44\1\u0196\25\44"+
    "\2\0\6\44\1\64\1\44\1\u0197\30\44\2\0\1\44"+
    "\1\u0197\31\44\2\0\6\44\1\64\11\44\1\u010b\20\44"+
    "\2\0\11\44\1\u010b\21\44\2\0\6\44\1\64\14\44"+
    "\1\u0198\15\44\2\0\13\44\1\u0198\15\44\37\0\1\u0199"+
    "\32\0\1\u0199\34\0\1\u019a\32\0\1\u019a\53\0\1\u019b"+
    "\32\0\1\u019b\24\0\1\u015c\33\0\1\u015c\45\0\1\u019c"+
    "\33\0\1\u019c\37\0\1\u019d\33\0\1\u019d\53\0\1\u0114"+
    "\33\0\1\u0114\46\0\1\u019e\32\0\1\u019e\15\0\2\44"+
    "\2\0\6\44\1\64\1\44\1\u019f\30\44\2\0\1\44"+
    "\1\u019f\27\44\14\0\1\u01a0\33\0\1\u01a0\36\0\3\u01a1"+
    "\66\0\2\44\2\0\6\44\1\64\1\44\1\u01a2\30\44"+
    "\2\0\1\44\1\u01a2\31\44\2\0\6\44\1\64\22\44"+
    "\1\u01a3\7\44\2\0\21\44\1\u01a3\11\44\2\0\6\44"+
    "\1\64\25\44\1\u01a4\4\44\2\0\24\44\1\u01a4\6\44"+
    "\2\0\6\44\1\64\5\44\1\u0163\24\44\2\0\5\44"+
    "\1\u0163\23\44\7\0\3\u01a5\102\0\1\u01a6\33\0\1\u01a6"+
    "\64\0\1\u01a7\32\0\1\u01a7\47\0\1\u01a8\32\0\1\u01a8"+
    "\24\0\1\u0168\33\0\1\u0168\51\0\1\u01a9\32\0\1\u01a9"+
    "\16\0\45\u01aa\1\0\32\u01aa\45\u0191\1\u01ab\32\u0191\2\44"+
    "\2\0\6\44\1\64\32\44\2\0\1\u01ac\32\44\2\0"+
    "\6\44\1\64\14\44\1\u01ad\15\44\2\0\13\44\1\u01ad"+
    "\17\44\2\0\6\44\1\64\5\44\1\u01ae\24\44\2\0"+
    "\5\44\1\u01ae\23\44\26\0\1\u01af\32\0\1\u01af\16\0"+
    "\2\44\2\0\6\44\1\64\7\44\1\u010b\22\44\2\0"+
    "\7\44\1\u010b\23\44\2\0\6\44\1\64\22\44\1\u0153"+
    "\7\44\2\0\21\44\1\u0153\11\44\2\0\6\44\1\64"+
    "\11\44\1\u01b0\20\44\2\0\11\44\1\u01b0\17\44\47\0"+
    "\1\u01b1\57\0\1\u01b2\32\0\1\u01b2\35\0\1\u01b3\33\0"+
    "\1\u01b3\45\0\1\u0114\33\0\1\u0114\56\0\1\u015c\32\0"+
    "\1\u015c\33\0\1\u01b4\33\0\1\u01b4\17\0\2\44\2\0"+
    "\6\44\1\64\23\44\1\u01b5\6\44\2\0\22\44\1\u01b5"+
    "\6\44\36\0\1\u01b6\32\0\1\u01b6\15\0\3\u01a1\34\0"+
    "\1\u01b7\31\0\2\44\2\0\6\44\1\64\14\44\1\u0188"+
    "\15\44\2\0\13\44\1\u0188\17\44\2\0\6\44\1\64"+
    "\17\44\1\u0163\12\44\2\0\16\44\1\u0163\14\44\2\0"+
    "\6\44\1\64\24\44\1\u01b8\5\44\2\0\23\44\1\u01b8"+
    "\5\44\7\0\3\u01a5\34\0\1\u01b9\60\0\1\u018d\32\0"+
    "\1\u018d\47\0\1\u0168\32\0\1\u0168\51\0\1\u01ba\32\0"+
    "\1\u01ba\36\0\1\u01bb\32\0\1\u01bb\13\0\45\u01aa\1\u01bc"+
    "\32\u01aa\6\0\1\u01bd\71\0\2\44\2\0\6\44\1\64"+
    "\20\44\1\u01be\1\44\1\u0176\7\44\2\0\17\44\1\u01be"+
    "\1\44\1\u0176\11\44\2\0\6\44\1\64\17\44\1\u010b"+
    "\12\44\2\0\16\44\1\u010b\14\44\2\0\6\44\1\331"+
    "\32\44\2\0\1\u01bf\30\44\31\0\1\u01c0\32\0\1\u01c0"+
    "\13\0\2\44\2\0\6\44\1\64\1\44\1\u01c1\30\44"+
    "\2\0\1\44\1\u01c1\27\44\33\0\1\u01c2\1\0\1\u017e"+
    "\30\0\1\u01c2\1\0\1\u017e\41\0\1\u0114\32\0\1\u0114"+
    "\24\0\1\340\34\0\1\u01c3\44\0\1\u01c4\33\0\1\u01c4"+
    "\27\0\2\44\2\0\6\44\1\64\23\44\1\u01c5\6\44"+
    "\2\0\22\44\1\u01c5\6\44\36\0\1\u01c6\32\0\1\u01c6"+
    "\6\0\45\u01c7\1\0\32\u01c7\2\44\2\0\6\44\1\64"+
    "\1\44\1\u01c8\30\44\2\0\1\44\1\u01c8\27\44\14\0"+
    "\1\u01c9\33\0\1\u01c9\75\0\1\u01ca\37\0\1\u01cb\120\0"+
    "\1\u01cc\32\0\1\u01cc\15\0\2\44\2\0\6\44\1\64"+
    "\22\44\1\u01cd\7\44\2\0\21\44\1\u01cd\11\44\2\0"+
    "\6\44\1\64\1\44\1\u01ce\30\44\2\0\1\44\1\u01ce"+
    "\27\44\46\0\1\u01cf\31\0\2\44\2\0\6\44\1\64"+
    "\16\44\1\u01d0\13\44\2\0\15\44\1\u01d0\13\44\35\0"+
    "\1\u01d1\32\0\1\u01d1\23\0\1\u01d2\33\0\1\u01d2\60\0"+
    "\1\u01d3\32\0\1\u01d3\13\0\2\44\2\0\6\44\1\u01d4"+
    "\32\44\2\0\31\44\12\0\1\u01d5\65\0\45\u01c7\1\u01d6"+
    "\32\u01c7\2\44\2\0\6\44\1\64\22\44\1\u01d7\7\44"+
    "\2\0\21\44\1\u01d7\7\44\35\0\1\u01d8\32\0\1\u01d8"+
    "\36\0\1\u01d9\32\0\1\u01d9\43\0\1\u01da\32\0\1\u01da"+
    "\16\0\2\44\2\0\6\44\1\64\17\44\1\u01db\12\44"+
    "\2\0\16\44\1\u01db\14\44\2\0\6\44\1\64\20\44"+
    "\1\u012c\11\44\2\0\17\44\1\u012c\11\44\1\0\2\u01dc"+
    "\1\0\1\u01dd\1\u01dc\37\0\1\u01de\1\0\1\u01dc\30\0"+
    "\2\44\2\0\6\44\1\64\31\44\1\361\2\0\30\44"+
    "\1\361\32\0\1\u01df\32\0\1\u01df\45\0\1\u0136\32\0"+
    "\1\u0136\55\0\1\371\32\0\1\371\7\0\3\u01e0\75\0"+
    "\3\u01e1\74\0\1\u01e2\71\0\2\44\2\0\6\44\1\64"+
    "\11\44\1\u01e3\20\44\2\0\11\44\1\u01e3\17\44\24\0"+
    "\1\u01e4\33\0\1\u01e4\45\0\1\u01e5\32\0\1\u01e5\47\0"+
    "\1\u01e6\32\0\1\u01e6\13\0\2\44\2\0\6\44\1\64"+
    "\26\44\1\u010b\3\44\2\0\25\44\1\u010b\3\44\31\0"+
    "\1\u01e7\32\0\1\u01e7\42\0\1\u01e8\32\0\1\u01e8\56\0"+
    "\1\u0114\32\0\1\u0114\12\0\3\u01e0\34\0\1\u01e9\40\0"+
    "\3\u01e1\34\0\1\u01ea\60\0\1\u01eb\32\0\1\u01eb\15\0"+
    "\2\44\2\0\6\44\1\64\1\44\1\u0163\30\44\2\0"+
    "\1\44\1\u0163\27\44\14\0\1\u0168\33\0\1\u0168\60\0"+
    "\1\u01ec\32\0\1\u01ec\61\0\1\u01ed\46\0\1\u01ee\33\0"+
    "\1\u01ee\54\0\1\u01ef\32\0\1\u01ef\16\0\45\u01f0\1\0"+
    "\32\u01f0\26\0\1\u01f1\32\0\1\u01f1\64\0\1\u01f2\67\0"+
    "\1\u01f3\32\0\1\u01f3\37\0\1\u01f4\32\0\1\u01f4\13\0"+
    "\45\u01f0\1\u01f5\32\u01f0\31\0\1\u01f6\32\0\1\u01f6\46\0"+
    "\1\u01f7\32\0\1\u01f7\23\0\1\u01f8\73\0\1\u01f9\137\0"+
    "\1\u01fa\44\0\1\u01dc\102\0\1\u01fb\11\0\1\u01fc\4\0"+
    "\1\u01fd\1\u01fe\13\0\1\u01fb\10\0\1\u01fc\4\0\1\u01fd"+
    "\1\u01fe\35\0\1\u01ff\32\0\1\u01ff\16\0\2\u01fa\1\0"+
    "\1\u0200\1\u01fa\37\0\1\u0201\1\0\1\u01fa\54\0\1\u0202"+
    "\2\0\1\u0203\30\0\1\u0202\1\0\1\u0203\55\0\1\u0204"+
    "\32\0\1\u0204\24\0\1\u0205\33\0\1\u0205\62\0\1\u0206"+
    "\32\0\1\u0206\33\0\1\u0207\32\0\1\u0207\47\0\1\u0208"+
    "\32\0\1\u0208\42\0\1\u0209\32\0\1\u0209\54\0\1\u020a"+
    "\32\0\1\u020a\54\0\1\u020b\61\0\1\u020c\32\0\1\u020c"+
    "\35\0\1\u020d\33\0\1\u020d\54\0\1\u020e\32\0\1\u020e"+
    "\42\0\1\u020f\32\0\1\u020f\30\0\1\u0210\33\0\1\u0210"+
    "\54\0\1\u0211\32\0\1\u0211\61\0\1\u0212\32\0\1\u0212"+
    "\20\0\1\u0213\16\0\1\u0214\14\0\1\u0213\15\0\1\u0214"+
    "\32\0\1\u0215\33\0\1\u0215\43\0\1\u0216\33\0\1\u0216"+
    "\61\0\1\u0217\32\0\1\u0217\50\0\1\u0218\67\0\1\u0219"+
    "\32\0\1\u0219\37\0\1\u021a\32\0\1\u021a\25\0\1\u021b"+
    "\105\0\1\u021c\33\0\1\u021c\43\0\1\u021d\33\0\1\u021d"+
    "\41\0\1\u021e\33\0\1\u021e\57\0\1\u021f\32\0\1\u021f"+
    "\24\0\1\u0220\66\0\2\u0218\1\0\1\u0221\1\u0218\37\0"+
    "\1\u0222\1\0\1\u0218\63\0\1\u0223\32\0\1\u0223\23\0"+
    "\1\u0224\65\0\2\u021b\2\0\6\u021b\1\340\32\u021b\2\0"+
    "\31\u021b\37\0\1\u0225\32\0\1\u0225\23\0\1\u0226\33\0"+
    "\1\u0226\51\0\1\u0227\33\0\1\u0227\50\0\1\u0212\32\0"+
    "\1\u0212\13\0\2\u0220\2\0\6\u0220\1\u0228\32\u0220\2\0"+
    "\31\u0220\31\0\1\u0229\32\0\1\u0229\42\0\1\u022a\32\0"+
    "\1\u022a\30\0\1\u01fa\102\0\1\u022b\17\0\1\u022c\13\0"+
    "\1\u022b\16\0\1\u022c\22\0\1\u022d\33\0\1\u022d\66\0"+
    "\1\u020d\32\0\1\u020d\40\0\1\u022e\32\0\1\u022e\20\0"+
    "\3\u022f\103\0\1\u0230\33\0\1\u0230\54\0\1\u0231\32\0"+
    "\1\u0231\45\0\1\u0232\32\0\1\u0232\54\0\1\u0233\32\0"+
    "\1\u0233\23\0\1\u0234\33\0\1\u0234\41\0\1\u0235\33\0"+
    "\1\u0235\36\0\3\u022f\34\0\1\u0236\67\0\1\u0237\32\0"+
    "\1\u0237\37\0\1\u0238\32\0\1\u0238\62\0\1\u0239\63\0"+
    "\1\u023a\32\0\1\u023a\34\0\1\u023b\33\0\1\u023b\47\0"+
    "\1\u023c\32\0\1\u023c\15\0\45\u023d\1\0\32\u023d\33\0"+
    "\1\u023e\32\0\1\u023e\23\0\1\u023f\101\0\1\u0240\33\0"+
    "\1\u0240\71\0\1\u0241\32\0\1\u0241\22\0\1\u0242\33\0"+
    "\1\u0242\47\0\1\u0202\33\0\1\u0202\17\0\45\u023d\1\u0243"+
    "\32\u023d\13\0\1\u0218\102\0\1\u0244\17\0\1\u0245\13\0"+
    "\1\u0244\16\0\1\u0245\46\0\1\u0246\32\0\1\u0246\16\0"+
    "\1\u0247\104\0\1\u0212\33\0\1\u0212\32\0\1\u0248\120\0"+
    "\1\u0249\32\0\1\u0249\54\0\1\u024a\32\0\1\u024a\44\0"+
    "\1\u024b\32\0\1\u024b\5\0\2\u0247\2\0\6\u0247\1\u0189"+
    "\32\u0247\2\0\31\u0247\27\0\1\u024c\32\0\1\u024c\64\0"+
    "\1\u024d\63\0\1\u024e\32\0\1\u024e\34\0\1\u024f\33\0"+
    "\1\u024f\46\0\1\u0250\32\0\1\u0250\54\0\1\u0251\32\0"+
    "\1\u0251\50\0\1\u0252\32\0\1\u0252\14\0\1\u0253\116\0"+
    "\1\u0254\32\0\1\u0254\33\0\1\u0255\33\0\1\u0255\35\0"+
    "\1\u0256\103\0\1\u0257\33\0\1\u0257\73\0\1\u01dc\47\0"+
    "\1\u0258\33\0\1\u0258\25\0\2\u0256\2\0\6\u0256\1\u01d5"+
    "\32\u0256\2\0\31\u0256\32\0\1\u0259\32\0\1\u0259\51\0"+
    "\1\u025a\32\0\1\u025a\42\0\1\u025b\32\0\1\u025b\33\0"+
    "\1\u025c\33\0\1\u025c\56\0\1\u025d\32\0\1\u025d\37\0"+
    "\1\u025e\32\0\1\u025e\32\0\1\u025f\33\0\1\u025f\54\0"+
    "\1\u0260\32\0\1\u0260\62\0\1\u0261\42\0\1\u0262\103\0"+
    "\1\u0263\33\0\1\u0263\36\0\1\u0264\7\0\1\u0265\5\0"+
    "\1\u0266\7\0\1\u0267\1\u0268\14\0\1\u0265\4\0\1\u0266"+
    "\7\0\1\u0267\1\u0268\20\0\1\u0269\33\0\1\u0269\34\0"+
    "\1\u026a\112\0\1\u026b\33\0\1\u026b\37\0\1\u026c\33\0"+
    "\1\u026c\64\0\1\u026d\32\0\1\u026d\40\0\1\u026e\32\0"+
    "\1\u026e\51\0\1\u026f\32\0\1\u026f\16\0\1\u0270\124\0"+
    "\1\u0271\32\0\1\u0271\50\0\1\u0272\32\0\1\u0272\27\0"+
    "\1\u0273\33\0\1\u0273\43\0\1\u0274\33\0\1\u0274\55\0"+
    "\1\u0270\32\0\1\u0270\20\0\1\u0275\111\0\1\u0276\33\0"+
    "\1\u0276\51\0\1\u0277\32\0\1\u0277\27\0\1\u0278\33\0"+
    "\1\u0278\65\0\1\u0279\32\0\1\u0279\14\0\3\u027a\102\0"+
    "\1\u027b\33\0\1\u027b\64\0\1\u027c\32\0\1\u027c\47\0"+
    "\1\u027d\32\0\1\u027d\24\0\1\u0270\33\0\1\u0270\32\0"+
    "\3\u027a\34\0\1\u027e\60\0\1\u0279\32\0\1\u0279\47\0"+
    "\1\u0270\32\0\1\u0270\51\0\1\u027f\32\0\1\u027f\5\0"+
    "\45\u0280\1\0\32\u0280\14\0\1\u0281\33\0\1\u0281\27\0"+
    "\45\u0280\1\u0282\32\u0280\35\0\1\u0283\32\0\1\u0283\15\0"+
    "\1\u0284\115\0\1\u0285\33\0\1\u0285\46\0\1\u0286\32\0"+
    "\1\u0286\31\0\1\u0270\33\0\1\u0270\55\0\1\u0287\32\0"+
    "\1\u0287\47\0\1\u0288\32\0\1\u0288\61\0\1\u0289\31\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[40640];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\105\0\1\11\261\0\1\1\31\0\1\11\147\0"+
    "\1\11\50\0\1\1\22\0\1\11\4\0\1\1\31\0"+
    "\1\1\3\0\1\11\4\0\1\11\226\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[649];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S144_ExtendAuthorities() { }
		
	private AnnotationEntity authEntity = null;
	
	private AnnotationEntity clSectionEntity = null;
	
	private String originalText = "";
	private int originalPosition = 0;



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S144_ExtendAuthorities(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 12: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 13: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}

			//Uscita
			
			addEntity(authEntity);
			
			yybegin(0);
		}
            }
          // fall through
          case 14: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 15: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 16: break;
          case 6:
            { if(offset == length) {

			//Uscita
			
			addEntity(authEntity);
					
			yypushback(yylength());
			yybegin(0);

		} else {
		
			AnnotationEntity retrievedEntity = retrieveEntity();
			
			offset += yylength();
			position += retrievedEntity.getText().length();
		}
            }
          // fall through
          case 17: break;
          case 7:
            { AnnotationEntity item = retrieveEntity();
		
		authEntity.addRelatedEntity(item);
		
		offset += yylength();
		position += item.getText().length();
            }
          // fall through
          case 18: break;
          case 8:
            { authEntity = retrieveEntity();
		
		authEntity.setText(originalText);
		authEntity.setPosition(originalPosition);
		
		if(clSectionEntity != null) authEntity.addRelatedEntity(clSectionEntity);
		
		offset += yylength();
		position += authEntity.getText().length();
            }
          // fall through
          case 19: break;
          case 9:
            { //System.out.println("CL_AUTH_EXT: " + yytext());
	
	authEntity = null;
	clSectionEntity = null;
	
	originalText = Util.removeAllAnnotations(yytext());
	originalPosition = position;
	
	start(null, extendAuth, false, false);
            }
          // fall through
          case 20: break;
          case 10:
            { AnnotationEntity item = retrieveEntity();
		
		clSectionEntity = item;

		if(authEntity != null) authEntity.addRelatedEntity(item);
		
		//Se erano presenti innner authorities vanno rimosse
		if(item.getRelatedEntity(Entity.CL_AUTH) != null) {
			
			getLinkolnDocument().removeAnnotationEntity(item.getRelatedEntity(Entity.CL_AUTH));
			item.removeRelatedEntity(Entity.CL_AUTH);
		}

		offset += yylength();
		position += item.getText().length();
            }
          // fall through
          case 21: break;
          case 11:
            { AnnotationEntity item = retrieveEntity();

		authEntity.addRelatedEntity(item);
		
		offset += yylength();
		position += item.getText().length();
            }
          // fall through
          case 22: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S144_ExtendAuthorities [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S144_ExtendAuthorities scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S144_ExtendAuthorities(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
